export interface ICancelAsyncToken {
    isCancelled: boolean;
    reason: string;
    cancel(): void;
    cancel(reason: string): void;
    onCancelled(delegate: () => void): void;
}
export declare function getCancellableAsyncToken(promise: Promise<any>): ICancelAsyncToken;
export declare function cancellableAsync<T extends (...args: any[]) => Promise<any>>(delegate: (token: ICancelAsyncToken) => T): T;
export declare function cancellableAsync(target: Object, propertyKey: PropertyKey, descriptor: TypedPropertyDescriptor<(...args: any[]) => Promise<any>>): TypedPropertyDescriptor<(...args: any[]) => Promise<any>>;
